=== binr/rafind2/Makefile ===
BIN=rafind2

BINDEPS=r_search r_io r_asm r_anal r_reg r_cons r_lang
BINDEPS+=r_socket r_parse r_util r_syscall r_flag

include ../rules.mk

include ../../libr/socket/deps.mk
include ../../shlr/zip/deps.mk
include ../../shlr/gdb/deps.mk
include ../../shlr/bochs/deps.mk
include ../../shlr/qnx/deps.mk
