=== debian/changelog ===
radare2 (1.6.0+dfsg-1) unstable; urgency=medium

  * New upstream release
   - Fix for CVE-2017-9520 (Closes: #864533)
     The r_config_set function in libr/config/config.c in radare2 1.5.0
     allows remote attackers to cause a denial of service (use-after-free
     and application crash) via a crafted DEX file.
   - Fix for CVE-2017-9949 (Closes: #866068)
     The grub_memmove function in shlr/grub/kern/misc.c in radare2 1.5.0
     allows remote attackers to cause a denial of service (stack-based
     buffer underflow and application crash) or possibly have unspecified
     other impact via a crafted binary file, possibly related to a buffer
     underflow in fs/ext2.c in GNU GRUB 2.02.
   - Fix for CVE-2017-10929 (Closes: #867369)
     The grub_memmove function in shlr/grub/kern/misc.c in radare2 1.5.0
     allows remote attackers to cause a denial of service (heap-based buffer
     overflow and application crash) or possibly have unspecified other
     impact via a crafted binary file, possibly related to a read overflow
     in the grub_disk_read_small_real function in kern/disk.c in GNU GRUB
     2.02.
  * Switch to Debian Standard Version 4.0.0

 -- Sebastian Reichel <sre@debian.org>  Thu, 13 Jul 2017 00:05:39 +0200

radare2 (1.5.0+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Sebastian Reichel <sre@debian.org>  Wed, 31 May 2017 18:14:20 +0200

radare2 (1.4.0+dfsg-1) experimental; urgency=medium

  * New upstream release
    - Dropped cherry picked patches (applied upstream)

 -- Sebastian Reichel <sre@debian.org>  Tue, 18 Apr 2017 22:34:57 +0200

radare2 (1.3.0+dfsg-2) experimental; urgency=medium

  * Add upstream patch to fix CVE-2017-7274 (Closes: #858873)

 -- Sebastian Reichel <sre@debian.org>  Wed, 29 Mar 2017 00:53:13 +0200

radare2 (1.3.0+dfsg-1) experimental; urgency=low

  * New upstream release
    - Dropped cherry picked patches (applied upstream)

 -- Sebastian Reichel <sre@debian.org>  Mon, 13 Mar 2017 16:14:13 +0100

radare2 (1.2.1+dfsg-5) experimental; urgency=high

  * Add upstream patches to fix security bugs
    - CVE-2017-6415 (Closes: #856572)
      The dex_parse_debug_item function in libr/bin/p/bin_dex.c in radare2
      1.2.1 allows remote attackers to cause a denial of service (NULL
      pointer dereference and application crash) via a crafted DEX file.
    - CVE-2017-6387 (Closes: #856574)
      The dex_loadcode function in libr/bin/p/bin_dex.c in radare2 1.2.1
      allows remote attackers to cause a denial of service (out-of-bounds
      read and application crash) via a crafted DEX file.
    - CVE-2017-6319 (Closes: #856579)
      The dex_parse_debug_item function in libr/bin/p/bin_dex.c in radare2
      1.2.1 allows remote attackers to cause a denial of service (buffer
      overflow and application crash) or possibly have unspecified other
      impact via a crafted DEX file.
  * Add small patch from Graham Inggs to fix FTBFS when
    linked with as-needed (Closes: #856329)

 -- Sebastian Reichel <sre@debian.org>  Fri, 03 Mar 2017 06:24:35 +0100

radare2 (1.2.1+dfsg-4) experimental; urgency=high

  * Add upstream patch to fix security bug (Closes: #856063)
    - CVE-2017-6197
      The r_read_* functions in libr/include/r_endian.h in radare2 1.2.1
      allows remote attackers to cause a denial of service (NULL pointer
      dereference and application crash) via a crafted binary file, as
      demonstrated by the r_read_le32 function.

 -- Sebastian Reichel <sre@debian.org>  Sat, 25 Feb 2017 02:38:12 +0100

radare2 (1.2.1+dfsg-3) experimental; urgency=medium

  * Add upstream patch to fix hurd build

 -- Sebastian Reichel <sre@debian.org>  Thu, 09 Feb 2017 20:29:23 +0100

radare2 (1.2.1+dfsg-2) experimental; urgency=medium

  * Fix build on architectures without debugger support via cherry-picked
    upstream patch

 -- Sebastian Reichel <sre@debian.org>  Mon, 06 Feb 2017 19:01:59 +0100

radare2 (1.2.1+dfsg-1) experimental; urgency=medium

  * New upstream release
   - bugfixes
  * Drop patch (fixed upstream)

 -- Sebastian Reichel <sre@debian.org>  Sun, 05 Feb 2017 07:12:19 +0100

radare2 (1.2.0+dfsg-1) experimental; urgency=low

  * New upstream release
   - Lots of new features
   - misc. bugfixes
  * Add patch to fix build with capstone 3.0.4

 -- Sebastian Reichel <sre@debian.org>  Tue, 31 Jan 2017 22:36:51 +0100
