=== debian/control ===
Source: radare2
Section: devel
Priority: extra
Maintainer: Sebastian Reichel <sre@debian.org>
Build-Depends: debhelper (>= 10~),
               flex,
               gobject-introspection,
               libcapstone-dev,
               libgmp3-dev,
               liblua5.1-0-dev,
               libkvm-dev [kfreebsd-any],
               libmagic-dev,
               libzip-dev,
               swig,
               valabind (>> 0.8.0),
               valac,
               python-dev,
               liblua5.2-dev,
               zlib1g-dev
Standards-Version: 4.0.0
Homepage: https://www.radare.org
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/radare2.git
Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/radare2.git

Package: radare2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libradare2-dev
Description: free and advanced command line hexadecimal editor
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.

Package: libradare2-1.6
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libradare2-common (>= ${source:Version})
Multi-Arch: same
Description: libraries from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the libraries from radare2.

Package: libradare2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libradare2-1.6 (= ${binary:Version}), libmagic-dev
Description: devel files from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the devel files from radare2.

Package: libradare2-common
Multi-Arch: foreign
Architecture: all
Depends: ${misc:Depends}
Description: arch independent files from the radare2 suite
 The project aims to create a complete, portable, multi-architecture,
 unix-like toolchain for reverse engineering.
 .
 It is composed by an hexadecimal editor (radare) with a wrapped IO
 layer supporting multiple backends for local/remote files, debugger
 (OS X, BSD, Linux, W32), stream analyzer, assembler/disassembler (rasm)
 for x86, ARM, PPC, m68k, Java, MSIL, SPARC, code analysis modules and
 scripting facilities. A bindiffer named radiff, base converter (rax),
 shellcode development helper (rasc), a binary information extractor
 supporting PE, mach0, ELF, class, etc. named rabin, and a block-based
 hash utility called rahash.
 .
 This package provides the arch independent files from radare2.
